%define is_mandrake %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)

Name:       dxirc
Version:    1.10.0
Summary: dxirc is simple IRC client. 
Release: 1
License: GPL
Group: Applications/Communications
%if %is_mandrake
# For spellchecking support
# Requires: libfox1.6_0 libpng3 openssl liblua5.1 enchant
# BuildRequires: libfox1.6-devel libpng-devel >= 1.2 libopenssl-devel liblua-devel libenchant-devel
Requires: libfox1.6_0 libpng3 openssl liblua5.1
BuildRequires: libfox1.6-devel libpng-devel >= 1.2 libopenssl-devel liblua-devel
%else
# For spellchecking support
# Requires: fox >= 1.6 libpng >= 1.2 openssl lua enchant
# BuildRequires: fox-devel >= 1.6 libpng-devel >= 1.2 openssl-devel lua-devel enchant-devel
Requires: fox >= 1.6 libpng >= 1.2 openssl lua
BuildRequires: fox-devel >= 1.6 libpng-devel >= 1.2 openssl-devel lua-devel
%endif
Source: %{name}-%{version}.tar.gz
Packager: David Vachulka <david@konstrukce-cad.com>
BuildRoot: %{_tmppath}/%{name}-buildroot

%description
dxirc is simple IRC client. dxirc is desktop independent and is written with the C++ Fox Toolkit.

%prep
%setup -q

%build
%configure --with-included-gettext --enable-release
make


%install
rm -rf %{buildroot}
%makeinstall
%find_lang %{name}
if [ -f %{buildroot}%{_datadir}/locale/locale.alias ]; then
    rm %{buildroot}%{_datadir}/locale/locale.alias
fi


%clean
rm -rf %{buildroot}

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS COPYING README TODO BUGS
%attr(755,root,root) %{_bindir}/*
%{_datadir}/dxirc/icons/*
%{_datadir}/dxirc/sounds/*
%{_datadir}/pixmaps/*
%{_datadir}/dxirc/COPYING
%{_datadir}/applications/dxirc.desktop
